-- NOTE: For use with FSUIPC 5 only

-- This small plug in, which should be pre-loaded: for example, by adding
-- [Auto] 
-- 1=Lua AIfreezer
-- to your FSUIPC5.INI file.

-- It freezes taxi-out AI traffic when you lower your gear,
-- and releases them when you touch down.

-- For aircraft with non-retractable gear, it checks the state of
-- the Flaps instead, expecting full flaps for landing. (amend where
-- noted for other flap settings).

function GroundCheck(off, val)
	if ipc.val ~= 0 then
		ipc.control(1149) -- Freeze AI off if user landed
		ipc.log("AI taxiout traffic released")
	end
end

function GearCheck(off, val)
	if val >= 16383 and ipc.readUW(0x0366) == 0 then
		ipc.control(1150) -- Freeze AI on if gear just lowered (whilst in the air)
		ipc.log("AI taxiout traffic frozen")
	end
end

function FlapsCheck(off, val)
	-- See if gear is fixed first:
	if ipc.readUB(0x060C) == 0 then
		if val >= 16383 and ipc.readUW(0x0366) == 0 then
			ipc.control(1150) -- Freeze AI on if now full flaps set when in the air
			ipc.log("AI taxiout traffic frozen")
		end
	end
end

event.offset(0x0366, "UW", "GroundCheck")
event.offset(0x0BE8, "UD", "GearCheck")
event.offset(0x0BDC, "UD", "FlapsCheck")

