-- Create the display window for 8 values, position x=800, y=400
h = display.create("Jason Fayre Display", 8, 800, 400)

-- Update the display at 1000 msec intervals (see event at end)
function mytimer(time)

    -- display 1 = airspeed
    airspeed = math.floor((ipc.readSD(0x02BC) / 128) + 0.5)
    display.show(h, 1, "Airspeed " .. airspeed .. " knots")
   
    -- display 2 = altitude
    altitude = math.floor(((ipc.readDD(0x0570) * 3.28084) / (65536 * 65536)) + 0.5)
    display.show(h, 2, "Altitude " .. altitude .. " feet")
   
    -- display 3 = heading
    heading = math.floor(((((ipc.readUD(0x0580)/65536) - ipc.readSW(0x02A0)) * 360) / 65536) + 0.5)
    display.show(h, 3, string.format("Headng %03d degrees", heading))
   
    -- display 4 = vertical speed
    vertspeed = math.floor(((ipc.readSD(0x02C8) * 60 * 3.28084) / 256) + 0.5)
    display.show(h, 4, "Vertical speed " .. vertspeed .. " knots")
       
    -- display 5 = mach
    mach = math.floor((ipc.readUW(0x11c6) / 204.80) + 0.5)
    display.show(h, 5, string.format("Mach %1.2f", mach/100))
   
    -- display 6 = Altimeter
    qnh = ipc.readUW(0x0330) / 16
    hPa = math.floor(qnh + 0.5)
    inches = math.floor(((100 * qnh * 29.92) / 1013.2) + 0.5)
    display.show(h, 6, string.format("Altimeter %d hPa, %2.2f inches", hPa, inches/100))
   
    -- display 7 = Radar Contact line 1 decode (waypoint)
    display.show(h, 7, RC1)
   
    -- display 8 = Radar Contact line 2 decode (runway)
    display.show(h, 8, RC2)
   
end

-- Adjust timing to taste: 1000 = 1 second
event.timer(1000, "mytimer")
