-- VRInsight example: displays Inches or Millibars, by Pete Dowson, March 2010
-- Needs these filters:
   -- WrFilter.1=BAR?
   -- RdFilter.1=BAR?+

speed = 115200 -- is this the same for all VRI devices?
handshake = 0  -- No handshake
minsize = 8
maxsize = 8    -- VRI seems to use fixed length blocks of 8 bytes

-- Uses local flag 0 as "use milibars" option.
-- Program a button or keypress to "LuaToggle VRI_SetBaro" with parameter 0

dev = com.open(VRIdevice, speed, handshake)

if dev == 0 then
   ipc.log("Could not open VRIdevice port")
   ipc.exit()
end

function setbarodisplay(off,val)
	 -- val is BARO setting in 16ths of millibar
	 if ipc.testflag(0) then
	 		-- need whole number of millibars
	 		val = (val + 8) / 16 -- Note rounding by addition of 8
	 else
	 	  -- need to convert to 100ths of inch
	 		val = ((val * 2992) / (1013.2 * 16)) + 0.5 -- note rounding	  
	 end
   str = string.format("BAR%04d", val)
	 com.write(dev, str, 8)
end

function setbarovalue(handle, str)
	-- need to check only for BARnnnn+/- and send correct millibars x 16 to FS
	baro = tonumber(string.match(str, "BAR(%d%d%d%d)"))
	if baro ~= nil then
			if ipc.testflag(0) then
					-- if flag set, using millibars
					baro = baro * 16 -- FS units are 16ths
			else
			    -- using inches
					baro = ((baro * 1013.2 * 16) / 2992) + 0.5 -- note rounding
			end
			ipc.writeUW(0x330, baro)
	end

end

setbarodisplay(0x330, ipc.readUW(0x330))

function flagchanged(n)
	setbarodisplay(0x330, ipc.readUW(0x330))
end

flagchanged(0) -- ensure initial value set

event.flag(0, "flagchanged")
event.offset(0x330, "UW", "setbarodisplay")
event.VRIread(dev, "setbarovalue")
