-- This is a plug-in which is automatically run by FSUIPC when you start any other
-- plug-in using the "Lua Debug" control. It uss the standard Lua debug library
-- facilities to provide a trace (by line numbers) of your developing Lua programs.
-- The results go to the LOG file for your Lua program, which is automatically created.

local function XXtraceXX(event, line)
  local s = debug.getinfo(2).short_src
  ipc.log(s .. ":" .. line)
end
local level=0

local function XXhookXX(event)
 local t=debug.getinfo(3)
 ipc.log(level," >>> ",string.rep(" ",level))
 if t~=nil and t.currentline>=0 then ipc.log(t.short_src,":",t.currentline," ") end
 t=debug.getinfo(2)
 if event=="call" then
  level=level+1
 else
  level=level-1 if level<0 then level=0 end
 end
 if t.what=="main" then
  if event=="call" then
   ipc.log("begin ",t.short_src)
  else
   ipc.log("end ",t.short_src)
  end
 elseif t.what=="Lua" then
  ipc.log(event," ",t.name or "(Lua)"," <",t.linedefined,":",t.short_src,">")
 else
 ipc.log(event," ",t.name or "(C)"," [",t.what,"] ")
 end
 ipc.log("\n")
end

debug.sethook(XXhookXX,"cr")
debug.sethook(XXtraceXX, "l")
level=0

