-- A (not very good) demo of event library facilities
--
-- Note: this isn't actually very useful at present. It is just an
-- example of using the Event facilities in a sort-of structured way
-- in order to accomplish some task.
--
-- The main problem here is that to provide landing assistance to the
-- pilot (as opposed to doing an autoland using the ILS) is far too
-- dependent uupon the aircraft, the pilot, the conditions, and here
-- I've been very unambitious, to avoid making the example so complex
-- as to make it rather obscure.

agl = 0
vs = 0

local function dochecks()
   if ipc.readUW(0x366) ~= 0 then
      -- on ground -- do landing roll actions

      ipc.log("dochecks: on ground") --##############################

      ipc.control(65604, 0) -- throttle cut
      ipc.control(65608, 0) -- elev down
      ipc.control(66064, 0) -- spoilers
      ipc.writeUW(0xC00, 0xC8C8) -- full left & right braking
      
      ipc.control(65608, 0) -- elev down
      ipc.control(65608, 0) -- elev down
      ipc.control(65820, -16383) -- full reverse, engine 1
      ipc.control(65821, -16383) -- full reverse, engine 2
      ipc.control(65822, -16383) -- full reverse, engine 3
      ipc.control(65823, -16383) -- full reverse, engine 4
      return 0
   
   elseif agl < 250 then
      if vs < -750 then
         ipc.control(65616, 0) -- elev up
      end
      if agl < 125 then
         ipc.control(65602, 0) -- throttle dec
         if agl < 30 then
            ipc.control(65616, 0) -- elev up again
            ipc.control(65604, 0) -- throttle cut
            ipc.control(65603, 0) -- flaps down
         end
      end
   end
   
   return 1
end


-- ==========================================

function calcgs(offs, val)
   gs = val * 3600 / 1852 -- to knots
   if gs < 20 then
      ipc.control(65604, 0) -- throttle cut
      ipc.writeUW(0xC00, 0) -- zero left & right braking
      ipc.control(65595, 0) -- flaps up
      ipc.control(66065, 0) -- spoilers down
      event.cancel("calcgs")
   end
end
   
local function endlanding()
   -- reset landing part
   event.cancel("calcagl")
   event.cancel("calcvs")
   
   -- enable restoration when GS low enough
   event.offset(0x02b6, "UW", "calcgs")  -- aircraft GS
end

alt = 0
gnd = 0

function calcagl(offs, val)
   if offs == 0x0B4C then
      gnd = val * 3.28084 -- ground alt
   elseif offs == 0x0574 then
      alt = val * 3.28084 -- aircraft alt
   end
   
   agl = alt - gnd
   
   if dochecks() == 0 then
      endlanding()
   end
end

function calcvs(offs, val)
   vs = val * -3.28084 -- VS in fpm

   if dochecks() == 0 then
      endlanding()
   end
end

-- ==========================================

gear = 0 -- to remember state  of gear control

function whengeardown(offs, val)
   if (gear == 0) and (val ~= 0) then
      -- initialise values
      gnd = ipc.readSW(0x0B4C) * 3.28084
      alt = ipc.readSD(0x0574) * 3.28084
      agl = alt - gnd
      vs = ipc.readSW(0x0842) * -3.28084 -- VS in fpm

      -- when the gear is put down, set the other events needed:     
      event.offset(0x0B4C, "SW", "calcagl")  -- ground alt in metres
      event.offset(0x0574, "SD", "calcagl")  -- aircraft alt in metres
      event.offset(0x0842, "SW", "calcvs")  -- aircraft vs
      
   end
   gear = val	
end

function reset(offs, val)
   gear = ipc.readUW(0x0BE8)
   
   -- these may not need cancelling, but
   -- it is best to be safe and does no harm
   event.cancel("calcgs")
   event.cancel("calcvs")
   event.cancel("calcagl")
end

-- to kick it all off:
event.offset(0x0BE8, "UW", "whengeardown")

-- to reset on a reload of flight or aircraft
event.offset(0x32FC, "UW", "reset")